#!/usr/bin/perl -w -T

$language = "./language.en";	# for english language uncomment this line
#$language = "./language.de";	# Fr deutsche Sprache das "#" zeichen entfernen
#$language = "./language.ru";	# for russian language uncomment this line

$emailfile = "./email.dat";	# this is the email database file that you wish to use,
				# normally you don't want to change the default value (email.dat).
$mailprog = "/usr/lib/sendmail";	# this is the full path to your sendmail binary.

$webmaster = "me\@mydomain.de";		# fill in your own email address. don't forget the backslash
					# in front of the @ sign! example: iamcool\@t-online.de
$newslettercookie = "newsletterpw102";



# This is for debugging only:
BEGIN {
    use CGI::Carp qw(carpout);	# Sends all errors to LOG
    open (LOG, ">> ./newspro.err") or die "Could not write to log file: $!\n";
    carpout(*LOG);
    };
##### end debugging #########





######################################################################
# ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! 
# ! ! ! DO NOT CHANGE ANYTHING BELOW IF YOU ARE NOT A PROGRAMMER  ! !
# ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! 
#
# here begins the program
# if you are no developer of this program you will never have to
# make any changes below!
# anyway, if you made useful changes to newspro please mail
# them to me: tr@erdfunkstelle.de!
########################################

$| = 1;					# this disables STDIO buffer and enables command buffering so STDERR will not be sent to browser before HTTP-headers
$progurl = $ENV{'SCRIPT_NAME'};		# Determine the location of this script
unless (stat($language)) { 		# have a look if the language file is present.
	&printheader("text/html"); 	# if not, modify some variables that would normally
	$txt{'53'} = "error";		# be set by the language file, and print an error
	$txt{'54'} = $txt{'53'};	# instead of a "error 500".
	&showmsg("red","language file not found!","NewsPro could not find the file \"$language\", please upload it to your newspro directory (same directory of $progurl)  with chmod 755 (rwxr-xr-x) in ASCII mode and try again.", "Javascript:history.back()"); 
	die; };
require "$language";			# this reads in the language file if it exists, else an error occurs
use locale;				# make use of servers language environment
use IO::File;				# use File module, needed for creating temp file within a 755 chmod environment
&parse_form_data (*simple_form);	# here we read in form data the browser passed to us
$version = "NewsPro v1.0.2";		# set version number. used for example in the bugreport form.
$footer = &showfooter;			# fill $footer with a standard site footer.

if (defined($simple_form{'action'})) {	# does only use variable for if-clause if it is defined
    my $do = $simple_form{'action'};	# read from web form or URL what to do and save action in $do
    if ($do eq "subscribe") {&do_subscribe; } 		# evaluate $do and decide what function should be called:
    elsif ($do eq "unsubscribe") {&do_unsubscribe; }
    elsif ($do eq "create_admin_passwd") {&do_create_admin_passwd; }
    elsif ($do eq "show_admin_center") {&do_show_admin_center; }
    elsif ($do eq "show_mail_status") {&do_show_mail_status; }
    elsif ($do eq "ac_change_passwd") {&do_ac_change_passwd; }
    elsif ($do eq "ac_showlist") {&do_ac_showlist; }
    elsif ($do eq "ac_writemail") {&do_ac_writemail; }
    elsif ($do eq "ac_writemail_preview") {&do_ac_writemail_preview; }
    elsif ($do eq "ac_writemail2") {&do_ac_writemail2; }
    elsif ($do eq "ac_download_db") {&do_ac_download_db; }
    elsif ($do eq "ac_bugreport") {&do_ac_bugreport; }
    elsif ($do eq "ac_bugreport2") {&do_ac_bugreport2; }
    elsif ($do eq "logout") {&do_logout; }
    elsif ($do eq "login") {&do_adminlogon; }
#   elsif ($do eq "helpimage") {&do_helpimage; }		# commented out... i will implement this in a later release!
#   elsif ($do eq "help") {&do_help; }				# commented out... i will implement this in a later release!
    else { &do_adminlogon; };				# fallback, will be used if a mistyped parameter is given to the script
} else {&do_adminlogon; };

## ==> end of the main program, 
## ==> below are the functions called by the main program

#######################################################################################
sub do_subscribe
{
### read in some variables from form:
$email = $simple_form{'emailadresse'};
$redirect_subscribe_okpage = $simple_form{'redirect_subscribe_okpage'};
$redirect_subscribe_errorpage = $simple_form{'redirect_subscribe_errorpage'};
$redirect_unsubscribe_okpage = $simple_form{'redirect_unsubscribe_okpage'};
$redirect_unsubscribe_errorpage = $simple_form{'redirect_unsubscribe_errorpage'};
### test if variables are filled, if not make them filled by a default ###
### making the admin-center the target is not very good but functional ###
### i will include a external-use function for showing a errormessage  ###
unless($redirect_subscribe_okpage) { $redirect_subscribe_okpage = "$progurl?show_admin_center" };
unless($redirect_subscribe_errorpage) { $redirect_subscribe_errorpage = "$progurl?show_admin_center"};
unless($redirect_unsubscribe_okpage) { $redirect_unsubscribe_okpage = "$progurl?show_admin_center" };
unless($redirect_unsubscribe_errorpage) { $redirect_unsubscribe_errorpage = "$progurl?show_admin_center"};

    # first, this deletes valid comments from the email adress:
    $email =~ s/\([^()]*\)//g;
    $email =~ s/\"[^()]*\"//g;
    $email =~ s/\<[^()]*\>//g;
    
    # now make emailadress lower case:
    $email_lc = lc($email);
    $email = $email_lc;

    # if it is not a valid email adress or contains invalid chars an error message is displayed:
    if (($email !~ /[\w]+\.*@[\w]+.*\.\w\w+/) or ($email =~ m/[\|\,\/\;\{\}\~\$\?]/g)) { 
	# redirect to the subscribe errorpage
	&printheader ("text/html");
	print "<meta http-equiv=\"refresh\" content=\"0; URL=$redirect_subscribe_errorpage\"></head></html>";
	die;
	};
    # check if email file already exists, if not it will be created
    unless(stat($emailfile)) { 
	unless (open(DBFILE, "> $emailfile")) {
	    &printheader ("text/html");
	    &showmsg("red","$txt{'602'}","$txt{'603'}", "Javascript:history.back()");
	    die;
	    }; 
	close DBFILE; 
	# secure the email file against writing by other persons
	#system("chmod 600 $emailfile");
	};
    # try to open the email file
    unless (open(DATEI_RO, "< $emailfile")) {
	&printheader ("text/html");
	&showmsg("red","$txt{'600'}","$txt{'601'}", "Javascript:history.back()");
	die;
	};

    # share lock the email file for further reading
    unless(flock(DATEI_RO, 1)) { &printheader ("text/html"); &showmsg("red","$txt{'613'}","$txt{'614'}","javascript:history.back()");die;};
    # look if the adress already exists in database
    while ($line = <DATEI_RO>) {
	chop($line); 	# remove "\n" at end of line
	if ($line eq "$email") {
	    &printheader ("text/html");
	    print "<meta http-equiv=\"refresh\" content=\"0; URL=$redirect_subscribe_errorpage\"></head></html>";
	    die;
	    };
	};
    close DATEI_RO;

# write the new adress to the database
    unless (open(DATEI_WO, ">> $emailfile")) { &printheader ("text/html"); &showmsg("red","$txt{'602'}","$txt{'603'}", "Javascript:history.back()");die;};
    # set exclusive lock for updating the email database
    unless(flock(DATEI_WO, 2)) { &printheader ("text/html"); &showmsg("red","$txt{'615'}","$txt{'616'}","javascript:history.back()");die; };
    print DATEI_WO "$email\n";
    close DATEI_WO;
    &do_inccounter;	# this increases the user counter

# print the redirect to the subscribe ok page
&printheader ("text/html");
print <<EOT;
<meta http-equiv="refresh" content="0; URL=$redirect_subscribe_okpage"></head></html>
EOT
}; # End of sub

#######################################################################################
sub do_unsubscribe
{
### read in variables from form:
$email = $simple_form{'emailadresse'};
$redirect_subscribe_okpage = $simple_form{'redirect_subscribe_okpage'};
$redirect_subscribe_errorpage = $simple_form{'redirect_subscribe_errorpage'};
$redirect_unsubscribe_okpage = $simple_form{'redirect_unsubscribe_okpage'};
$redirect_unsubscribe_errorpage = $simple_form{'redirect_unsubscribe_errorpage'};
### test if variables are filled, if not make them filled by a default ###
### making the admin-center the target is not very good but functional ###
### i will include a external-use function for showing a errormessage  ###
unless($redirect_subscribe_okpage) { $redirect_subscribe_okpage = "$progurl?show_admin_center" };
unless($redirect_subscribe_errorpage) { $redirect_subscribe_errorpage = "$progurl?show_admin_center"};
unless($redirect_unsubscribe_okpage) { $redirect_unsubscribe_okpage = "$progurl?show_admin_center" };
unless($redirect_unsubscribe_errorpage) { $redirect_unsubscribe_errorpage = "$progurl?show_admin_center"};

    # first make emailadress lower case:
    $email_lc = lc($email);
    $email = $email_lc;
    # check if emailadress can be found in database
    unless(open(DATEI_RO, "< $emailfile")) { &printheader ("text/html"); &showmsg("red","$txt{'600'}","$txt{'601'}", "Javascript:history.back()");die;};
    # share lock the email database
    unless(flock(DATEI_RO, 1)) { &printheader ("text/html"); &showmsg("red","$txt{'613'}","$txt{'614'}","javascript:history.back()");die;};
    $exitcode = 1;
    while ($line = <DATEI_RO>) {
	chop($line);
	# if adress was found set OK status ($exitcode=0)
	if ($line eq "$email") {
	    $exitcode = 0;
	};
    };
    close DATEI_RO;
    
    # check exitcode
    if ($exitcode != 0) { 	# the adress could not be found in database -> create the error redirect
	&printheader ("text/html");
	print "<meta http-equiv=\"refresh\" content=\"0; URL=$redirect_unsubscribe_errorpage\"></head></html>";
	die;
	};
    if ($exitcode == 0) {	# address was found. good :)
	# open file for read and write access. write access is needed for solaris-systems to get an exclusive lock
	# on a file from whitch we do only read....
	unless(open (ORIG, "+< $emailfile")) {
	    &printheader ("text/html");
	    &showmsg("red","$txt{'600'}","$txt{'601'}", "Javascript:history.back()");
	    die;
	    };
	# email adress was found. set exclusive lock for updating the email database
	unless(flock(ORIG, 2)) { &printheader ("text/html"); &showmsg("red","$txt{'613'}","$txt{'614'}","javascript:history.back()");die;};
	# open a temporary file
	unless($tempfile = IO::File->new_tmpfile) {
	    &printheader("text/html");
	    &showmsg("red","$txt{'602'}","$txt{'604'}","javascript:history.back()");
	    die;
	    };
	$tempfile->autoflush(1);
	# walk through the database and write everything but the unsubscribe adress to the temprorary filehandle
	while (<ORIG>) {
	    $data = $_;
	    chop($data);
	    if ($data ne $email) {
		print $tempfile "$data\n";
		};
	    };
	close ORIG;
	unless(open (ORIG, "> $emailfile")) {
	    &printheader ("text/html");
	    &showmsg("red","$txt{'600'}","$txt{'601'}", "Javascript:history.back()");
	    die;
	    };
	# set exclusive lock for updating the email database
	unless(flock(ORIG, 2)) { &printheader ("text/html"); &showmsg("red","$txt{'613'}","$txt{'614'}","javascript:history.back()");die;};
	# reset cursor position to the beginning of the tempfile
	seek($tempfile, 0, 0);
	# copy complete temporary file to our email database and close theese files
	print ORIG <$tempfile>;
	close ORIG;
	close $tempfile;
        &do_deccounter;	# this decreases the user counter
        # print the redirect to the unscubscribe ok page
        &printheader ("text/html");
        print "<meta http-equiv=\"refresh\" content=\"0; URL=$redirect_unsubscribe_okpage\"></head></html>";
        };
}; # end of sub

#######################################################################################
sub do_adminlogon
{
&printheader ("text/html");

# check if a cookie is available.
# if a cookie was sent we compare it with 
# the admin password and login if possible
$password = &loadcookie;
if (($password ne "invalid") && ($password)) {
    # if cookie contains the text "invalid" the user 
    # logged out the previous session and we can not
    # login automatically.
    unless (open(PWFILE, "< ./passwd.dat")) {
	&showmsg("red","$txt{'605'}","$txt{'606'}","javascript:history.back()");
	die;
	};
    unless(flock(PWFILE, 1)) { &showmsg("red","$txt{'617'}","$txt{'618'}","javascript:history.back()");die;};
    $line = <PWFILE>;
    close PWFILE;
    # if password compared successfully we will log in and show the admin center:
    if ($line eq $password) {
        print "<meta http-equiv=\"refresh\" content=\"0; URL=$progurl?action=show_admin_center\"></head></html>";
	close STDOUT;
	};
    };

# check if a password file already exists. if not, a password
# file will be created, if one exists the user will be 
# asked for the correct password.

# if password file exists, ask for the correct password:
my @fileexists = stat("./passwd.dat");
if ($fileexists[7] > 0) {
    print <<EOT;
<title>$txt{'100'}</title>
</head>
<body bgcolor="#bddeff" onLoad="javascript:document.adminlogon.passwort.focus();">
<center>
<table bgcolor="#bddeff" border="1" cellspacing="0" cellpadding="5">
<tr bgcolor="#297bce">
    <td align="center"><font face="arial, helvetica" color="#ffffff" size="5">$txt{'100'}</font></td>
</tr>
<tr>
    <td>
    <font size="3" face="arial, helvetica" color="#000000">$txt{'101'}:</font></td>
</tr>
<tr>
    <td>
	<table border="0" cellspacing="0" cellpadding="5">
	<tr>
	    <td align="left" valign="middle"><font size="2" face="arial, helvetica" color="#000000">$txt{'102'}:</font></td>
	    <td align="left" valign="middle"><font size="2" face="arial, helvetica" color="#000000">
		<form name="adminlogon" action="$progurl" method="POST" style="margin-bottom:0px;">
		<input type="hidden" name="action" value="show_admin_center">
		<font size="2" face="arial, helvetica"><input type="password" name="passwort" value="" size="18" maxlength"50">
		<input type="submit" name="submit" value="$btn{'1'}"></font>
		</form>
		</td>
	</tr>
	</table>
    </td>
</tr>
</table>
$footer
</center>
</body>
</html>
EOT
} else { 
# password file does not exist
    print <<EOT;
<title>$txt{'103'}</title>
</head>
<body bgcolor="#bddeff" onLoad="javascript:document.admineintrag.passwort1.focus();">
<center>
<table bgcolor="#bddeff" border="1" cellspacing="0" cellpadding="5">
<tr bgcolor="#297bce">
    <td align="center"><font face="arial, helvetica" color="#ffffff" size="5">$txt{'103'}</font></td>
</tr>
<tr>
    <td>
    <font size="3" face="arial, helvetica" color="#000000">$txt{'104'}:</font></td>
</tr>
<tr>
    <td>
	<font size="2" face="arial, helvetica" color="#ff0000">$txt{'105'}</font>
	<form name="admineintrag" action="$progurl" method="POST" style="margin-bottom:0px;">
	<input type="hidden" name="action" value="create_admin_passwd">
	<table border="0" width="100%" cellspacing="0" cellpadding="5">
	<tr>
	    <td align="right" width="50%" valign="middle"><font size="2" face="arial, helvetica" color="#000000">$txt{'102'} 1:</font></td>
	    <td align="left" width="50%" valign="middle"><font size="2" face="arial, helvetica" color="#000000"><input type="password" name="passwort1" value="" size="18" maxlength="50"</font></td>
	</tr>
	<tr>
	    <td align="right" width="50%" valign="middle"><font size="2" face="arial, helvetica" color="#000000">$txt{'102'} 2:</font></td>
	    <td align="left" width="50%" valign="middle"><font size="2" face="arial, helvetica" color="#000000"><input type="password" name="passwort2" value="" size="18" maxlength="50"</font></td>
	</tr>
	</table>
	<center><br><input type="submit" name="submit" value="$btn{'1'}"></center>
	</form>
    </td>
</tr>
</table>
$footer
</center>
</body>
</html>
EOT
    };

}; # end of sub

#######################################################################################
sub do_create_admin_passwd
{
# read in variables
$passwort1 = $simple_form{'passwort1'};
$passwort2 = $simple_form{'passwort2'};

# create password file if passwords are the same.
# but first we check if there is already a password file!
# if there is one, we will cancel this!
my @fileexists = stat("./passwd.dat");
if ($fileexists[7] > 0) {
    &printheader ("text/html");
    &showmsg("red","$txt{'625'}", "$txt{'626'}","javascript:history.back()");
    die "$progurl: $txt{'627'}";
} else {
    if (($passwort1 eq $passwort2) && ( $passwort1 ne "")) {
        unless (open(PASSWORT, "> ./passwd.dat")) {
	    &printheader ("text/html");
	    &showmsg("red", "$txt{'607'}", "$txt{'608'}","javascript:history.back()");
	    die;
	    };
	# set exclusive lock on password file
	unless(flock(PASSWORT, 2)) { &showmsg("red","$txt{'619'}","$txt{'620'}","javascript:history.back()");die; };
	# encrypt the password with salt 1
        $crypt_password = crypt($passwort1, 1);
        print PASSWORT $crypt_password;
        close PASSWORT;
	&setsecurepath;
	#system("chmod 600 ./passwd.dat");	# change file permissions
	# set new cookie containing the crypted password
	&printheader ("text/html","$newslettercookie=$crypt_password");
	$ENV{'HTTP_COOKIE'} = qq~$newslettercookie=$crypt_password~;
	&showmsg("green","$txt{'628'}","$txt{'629'}","#","$progurl?action=show_admin_center");
    } else {
	&printheader ("text/html");
	&showmsg("red","$txt{'630'}","$txt{'631'}","javascript:history.back()");
	die;
	};
    };
}; # end of sub

#######################################################################################
sub do_show_admin_center
{
print "Content-type: text/html\n";
    # extract password from web form
    if($simple_form{'passwort'}) {
	$passwort_form = crypt($simple_form{'passwort'}, 1);
	print "P3P: CP=\"NOI DSP COR DEVa TAIa OUR BUS UNI\"\n";	# This is for IE>6 to accept third party cookies if needed
	print "Set-cookie: $newslettercookie=$passwort_form\n";
	$ENV{'HTTP_COOKIE'} = qq~$newslettercookie=$passwort_form~;
    };
print "\n";
&checkpass;
my $counter = &do_getcounter;
print <<EOT;
<html>
<head>
<title>$txt{'200'}</title>
<meta http-equiv="content-type" content="text/html; charset=$charset">
<style type="text/css">
form { margin-bottom:0px; }
input { margin-bottom:0px;  }
</style>
</head>
<body bgcolor="#bddeff" onLoad="javascript:document.subscribe.emailadresse.focus();document.subscribe.emailadresse.select();">
<center>
<table bgcolor="#bddeff" border="1" cellspacing="0" cellpadding="5">
<tr bgcolor="297bce">
    <td align="center"><font face="arial, helvetica" color="#ffffff" size="5">$txt{'200'}</font></td>
</tr>
<tr>
    <td>
    <font size="3" face="arial, helvetica" color="#000000">$txt{'201'}:</font>
    </td>
</tr>
<tr>
    <td>
	<table border="0" cellspacing="0" cellpadding="5">
	<tr>
	    <td align="left" valign="middle"><font size="2" face="arial, helvetica" color="#000000">&nbsp;</font></td>
	    <td align="right" valign="middle"><font size="2" face="arial, helvetica" color="#000000">$txt{'209'}: $counter</font></td>
	</tr>
	<tr>
	    <td align="left" valign="middle"><font size="2" face="arial, helvetica" color="#000000">1. $txt{'202'}</font></td>
	    <td align="left" valign="middle"><form name="changepass" action="$progurl" method="POST" style="margin-bottom:0px;"><input type="hidden" name="action" value="ac_change_passwd"><input type="submit" name="submit" value="$btn{'3'}"></form></td>
	</tr>
	<tr>
	    <td align="left" valign="middle"><font size="2" face="arial, helvetica" color="#000000">2. $txt{'203'}</font></td>
	    <td align="left" valign="middle"><form name="memberlist" action="$progurl" method="POST" style="margin-bottom:0px;"><input type="hidden" name="action" value="ac_showlist"><input type="submit" name="submit" value="$btn{'3'}"></form></td>
	</tr>
	<tr>
	    <td align="left" valign="middle"><font size="2" face="arial, helvetica" color="#000000">3. $txt{'204'}</font></td>
	    <td align="left" valign="middle"><form name="writemail" action="$progurl" method="POST" style="margin-bottom:0px;"><input type="hidden" name="action" value="ac_writemail"><input type="submit" name="submit" value="$btn{'3'}"></form></td>
	</tr>
	<tr>
	    <td align="left" valign="middle"><font size="2" face="arial, helvetica" color="#000000">4. $txt{'205'}</font></td>
	    <td align="left" valign="middle"><form name="subscribe" action="$progurl" method="POST" style="margin-bottom:0px;"><input type="hidden" name="action" value="subscribe"><input type="text" name="emailadresse" value="$txt{'208'}" size="18" maxlength="50"><input type="hidden" name="redirect" value="$progurl?action=show_admin_center"><input type="submit" name="submit" value="$btn{'3'}"></form></td>
	</tr>
	<tr>
	    <td align="left" valign="middle"><font size="2" face="arial, helvetica" color="#000000">5. $txt{'206'}</font></td>
	    <td align="left" valign="middle"><form name="mailstatus" action="$progurl" method="POST" style="margin-bottom:0px;"><input type="hidden" name="action" value="show_mail_status"><input type="submit" name="submit" value="$btn{'3'}"></form></td>
	</tr>
	<tr>
	    <td align="left" valign="middle"><font size="2" face="arial, helvetica" color="#000000">&nbsp;</font></td>
	    <td align="left" valign="middle"><font size="2" face="arial, helvetica" color="#000000">&nbsp;</font></td>
	</tr>
	<tr>
	    <td align="left" valign="middle" colspan="2"><hr noshade width="100%"></td>
	</tr>
	<tr>
	    <td align="left" valign="middle"><font size="2" face="arial, helvetica" color="#000000">6. $txt{'207'}</font></td>
	    <td align="left" valign="middle"><form name="dbbackup" action="$progurl" method="POST" style="margin-bottom:0px;"><input type="hidden" name="action" value="ac_download_db"><input type="submit" name="submit" value="$btn{'3'}"></form></td>
	</tr>
	<tr>
	    <td align="left" valign="middle"><font size="2" face="arial, helvetica" color="#000000">7. $txt{'210'}</font></td>
	    <td align="left" valign="middle"><form name="bugreport" action="$progurl" method="POST" style="margin-bottom:0px;"><input type="hidden" name="action" value="ac_bugreport"><input type="submit" name="submit" value="$btn{'3'}"></form></td>
	</tr>
	</table>
	<br>
	<center><form name="admincenter" action="$progurl" method="POST" style="margin-bottom:0px;"><input type="hidden" name="action" value="logout"><input type="submit" name="submit" value="$btn{'2'}"></form></center>
    </td>
</tr>
</table>
$footer
</center>
</body>
</html>
EOT
}; # end of sub

#######################################################################################
sub do_show_mail_status
{
&printheader ("text/html");
&checkpass;
my @fileexists = stat("status.lck");
    unless ($fileexists[7] > 0) {
	&showmsg("red","$txt{'609'}","$txt{'610'}","javascript:history.back()");
	    die;
	    };
    open(STATUSFILE, "< status.lck");
    unless(flock(STATUSFILE, 1)) { &showmsg("red","$txt{'621'}","$txt{'622'}","javascript:history.back()");die;};
    my $status = <STATUSFILE>;
    close STATUSFILE;
    &showmsg("green","$txt{'632'}","$txt{'633'}:<br><br><b>$status</b><br><br>$txt{'634'}","$progurl","$progurl?action=show_mail_status");
}; # end of sub

#######################################################################################
sub do_ac_change_passwd
{
&checkpass ("text/html");
# read in variables from web form
$oldpw = $simple_form{'oldpw'};
$newpw1 = $simple_form{'newpw1'};
$newpw2 = $simple_form{'newpw2'};
# if variables are filled check if password change is permitted and do it.
# if not filled, ask for the passwords to change
if ($oldpw && $newpw1 && $newpw2) {
    unless (open(PWFILE, "< ./passwd.dat")) {
	&printheader ("text/html"); 
	&showmsg("red","$txt{'605'}","$txt{'606'}","javascript:history.back()");
	die;
	};
    unless(flock(PWFILE, 1)) { &printheader ("text/html"); &showmsg("red","$txt{'617'}","$txt{'618'}","javascript:history.back()");die;};
    $line = <PWFILE>;
    close PWFILE;
    $oldpw_form = crypt($oldpw, 1);
    # if old password matches the one from password file
    # check if the 2 new ones match themself
    # if everything is correct perform the password change
    if ($oldpw_form eq $line) {
        if ($newpw1 eq $newpw2) {
            unless (open(PWFILE, "> ./passwd.dat")) {
		&printheader ("text/html"); 
		&showmsg("red", "$txt{'607'}", "$txt{'608'}","javascript:history.back()");
		die;
		};
	    # set exclusive lock on password file
	    unless(flock(PWFILE, 2)) { &printheader ("text/html"); &showmsg("red","$txt{'619'}","$txt{'620'}","javascript:history.back()");die; };
            $crypt_password = crypt($newpw1, 1);
            print PWFILE $crypt_password;
            close PWFILE;
	    # set new cookie
	    &printheader ("text/html", "$newslettercookie=$crypt_password"); 
	    $ENV{'HTTP_COOKIE'} = qq~$newslettercookie=$crypt_password~;
	    &showmsg("green", "$txt{'635'}", "$txt{'636'}", "$progurl?action=ac_change_passwd","$progurl?action=show_admin_center");
    	} else { 
	    &printheader ("text/html"); 
	    &showmsg("red", "$txt{'637'}", "$txt{'638'}","$progurl?action=ac_change_passwd");
	    die;
	};
    } else {
    &printheader ("text/html"); 
    &showmsg("red", "$txt{'639'}", "$txt{'640'}", "$progurl?action=ac_change_passwd");
    die;
    };
    
} else {
    &printheader ("text/html"); 
    print <<EOT;
<title>$txt{'300'}</title>
</head>
<body bgcolor="#bddeff">
<center>
<table bgcolor="#bddeff" border="1" cellspacing="0" cellpadding="5">
<tr bgcolor="297bce">
    <td align="center"><font face="arial, helvetica "color="#ffffff" size="5">$txt{'300'}</font></td>
</tr>
<tr>
    <td>
    <font size="3" face="arial, helvetica" color="#000000">$txt{'301'}</font>
    </td>
</tr>
<tr>
    <td>
	<form name="admineintrag" action="$progurl" method="POST" style="margin-bottom:0px;">
	<input type="hidden" name="action" value="ac_change_passwd">
	<table border="0" width="100%" cellspacing="0" cellpadding="5">
	<tr>
	    <td align="right" valign="middle" width="50%"><font size="2" face="arial, helvetica" color="#000000">$txt{'302'}:</font></td>
	    <td align="left" valign="middle" width="50%"><font size="2" face="arial, helvetica" color="#000000"><input type="password" name="oldpw" value="" size="18" maxlength="50"</font></td>
	</tr>
	<tr>
	    <td align="right" valign="middle" width="50%"><font size="2" face="arial, helvetica" color="#000000">$txt{'303'}:</font></td>
	    <td align="left" valign="middle" width="50%"><font size="2" face="arial, helvetica" color="#000000"><input type="password" name="newpw1" value="" size="18" maxlength="50"</font></td>
	</tr>
	<tr>
	    <td align="right" valign="middle" width="50%"><font size="2" face="arial, helvetica" color="#000000">$txt{'303'}:<br><font size="1" face="arial, helvetica">($txt{'304'})</font></font></td>
	    <td align="left" valign="middle" width="50%"><font size="2" face="arial, helvetica" color="#000000"><input type="password" name="newpw2" value="" size="18" maxlength="50"</font></td>
	</tr>
	</table>
	<center><br><input type="submit" name="submit" value="$btn{'1'}"></center>
	</form>
	<br><center><a href="$progurl?action=show_admin_center">$txt{'1'}</a></center>
    </td>
</tr>
</table>
$footer
</center>
</body>
</html>
EOT
    };
}; # End of sub

#######################################################################################
sub do_ac_showlist
{
&printheader ("text/html"); 
&checkpass;
	# open email database
	unless (open(DBFILE, "< $emailfile")) {
	    &showmsg("red","$txt{'600'}","$txt{'601'}","javascript:history.back()");
	    die;
	    };
	unless(flock(DBFILE, 1)) { &showmsg("red","$txt{'613'}","$txt{'614'}","javascript:history.back()");die;};
	# read in email database
	my @emails_unsorted = <DBFILE>;
	close DBFILE;
	# if list should be unsorted (to have newest user at the end of the list for example)
	if ($simple_form{'showlist_sort'} eq "false") {
	    @emails = @emails_unsorted;
	    }
	else {	#else sort list
	    @emails = sort @emails_unsorted;
	    };

#    # which page should be shown:
    $pagenr = $simple_form{'showlist_nr'};
    if ($pagenr > ((@emails/50)+1)) {$pagenr = 1;};
    if ($pagenr < 1) {$pagenr = 1;};
    
    # render result-array for page $pagenr
    for ($i = 0; $i <= 49; $i++) {
	# Fill result-array if there is another emailadress in the source-array	
	if ($emails[((($pagenr*50)-50)+$i)]) { @emailresult[($i)] = $emails[((($pagenr*50)-50)+$i)]; };
	};
    # find out how many pages we have and where we are right now:
    my $pages_all = int((@emails/50)+1);
    my $pagenr_act = $pagenr;

    # print out the list to the browser:
	print "\n\n";
	print <<EOT;
<title>$txt{'400'}</title></head>
<body bgcolor="#bddeff">
<center>
<table bgcolor="#bddeff" border="1" cellspacing="0" cellpadding="5">
<tr bgcolor="297bce">
    <td align="center"><font face="arial, helvetica" color="#ffffff" size="5">$txt{'400'}</font></td>
</tr>
<tr>
    <td>
    <font size="2" face="arial, helvetica" color="#000000">$txt{'401'}
EOT
# print out the number of pages and generate the links to them:
for ($i=1; $i<=$pages_all; $i++) {
    if ($pagenr_act != $i) {print "<a href=\"$progurl?action=ac_showlist&showlist_nr=$i&showlist_sort=$simple_form{'showlist_sort'}\">$i</a> ";}
    else  {print "<font style=\"background-color:#ffffff;\">$i</font> ";};
    };
print <<EOT;
    <br>
EOT
    if ($simple_form{'showlist_sort'} ne "false") { print "<a href=\"$progurl?action=ac_showlist&showlist_nr=$pagenr_act&showlist_sort=false\">$txt{'403'}</a></font>"}
    else {print "<a href=\"$progurl?action=ac_showlist&showlist_nr=$pagenr_act&showlist_sort=true\">$txt{'402'}</a></font>"};
print <<EOT;
    </td>
</tr>
<tr>
    <td>
	<table border="0" width="100%" cellspacing="0" cellpadding="2">
EOT
	### print out up to 50 members from actual list ###
	foreach(@emailresult) {
	    chop($_);
	    print <<EOT;
	<tr>
	    <td align="center" valign="middle" width="50%"><font size="2" face="arial, helvetica" color="#000000"><form name="unsubscribe" action="$progurl" method="POST" style="margin-bottom:0px;"><input type="hidden" name="action" value="unsubscribe"><input type="hidden" name="emailadresse" value="$_"><input type="hidden" name="redirect_unsubscribe_okpage" value="$progurl?action=ac_showlist"><input type="submit" value="$btn{'4'} -&gt;"></form></font></td>
	    <td align="left" valign="middle" width="50%"><font size="2" face="arial, helvetica" color="#000000">$_</font></td>
	</tr>
EOT
	};
	print <<EOT;
	</table>
	</form>
    </td>
</tr>
<tr>
    <td>
    <font size="2" face="arial, helvetica" color="#000000">$txt{'401'}
EOT
    # print out the number of pages and generate the links to them:
    for ($i=1; $i<=$pages_all; $i++) {
        if ($pagenr_act != $i) {print "<a href=\"$progurl?action=ac_showlist&showlist_nr=$i&showlist_sort=$simple_form{'showlist_sort'}\">$i</a> ";}
        else  {print "<font style=\"background-color:#ffffff;\">$i</font> ";};
        };
    print <<EOT;    
    </font>
    <br><br><center><a href="$progurl?action=show_admin_center">$txt{'1'}</a></center>
    </td>
</tr>
</table>
$footer
</center>
</body>
</html>
EOT
}; # End ob sub
#######################################################################################
sub do_ac_writemail
{
&printheader ("text/html"); 
&checkpass;
	unless (open(DBFILE, "< $emailfile")) {
	    &showmsg("red","$txt{'600'}","$txt{'601'}", "Javascript:history.back()");
	    die;
	    };
	unless(flock(DBFILE, 1)) { &showmsg("red","$txt{'613'}","$txt{'614'}","javascript:history.back()");die;};
	# read in email adresses
	@emails = <DBFILE>;
	close DBFILE;
	print "\n\n";
	print<<EOT;
<title>$txt{'500'}</title></head>
<body bgcolor="#bddeff">
<center>
<table bgcolor="#bddeff" border="1" cellspacing="0" cellpadding="5">
<tr bgcolor="297bce">
    <td align="center"><font face="arial, helvetica" color="#ffffff" size="5">$txt{'500'}</font></td>
</tr>
<tr>
    <td>
    <font size="3" face="arial, helvetica" color="#000000">$txt{'501'}</font>
    </td>
</tr>
<tr>
    <td>
	<form name="newsletterwrite" action="$progurl" method="POST" style="margin-bottom:0px;">
	<input type="hidden" name="action" value="ac_writemail_preview">
	<table border="0" width="100%" cellspacing="0" cellpadding="5">
	<tr>
	    <td align="right"><font size="2" face="arial, helvetica" color="#000000">$txt{'502'}:</font></td>
	    <td align="left"><font size="2" face="arial, helvetica" color="#000000"><input type="text" name="absender" size="18" maxlength="50"></font></td>
	</tr>
	<tr>
	    <td align="right"><font size="2" face="arial, helvetica" color="#000000">$txt{'503'}:</font></td>
	    <td align="left"><font size="2" face="arial, helvetica" color="#000000"><input type="text" name="betreff" size="30" maxlength="120"></font></td>
	</tr>
	<tr>
	    <td align="right" valign="top"><font size="2" face="arial, helvetica" color="#000000">$txt{'504'}:</font></td>
	    <td align="left" valign="top"><font size="2" face="arial, helvetica" color="#000000"><textarea name="msgtxt" rows="30" cols="73" wrap="off"></textarea></font></td>
	</tr>
	</table>
	<center><br><input type="submit" name="submit" value="$btn{'5'}"></center>
	</form>
	<br><center><a href="$progurl?action=show_admin_center">$txt{'1'}</a></center>
    </td>
</tr>
</table>
$footer
</center>
</body>
</html>
EOT
}; # End of sub

#######################################################################################
sub do_ac_writemail_preview
{
my $absender = $simple_form{'absender'};
my $betreff = $simple_form{'betreff'};
my $msgtxt = $simple_form{'msgtxt'};
my $msgtxt_ntobr = $msgtxt;
$msgtxt_ntobr =~ s/\n/<br>/g;
$msgtxt_ntobr =~ s/ /&nbsp;/g;

&printheader ("text/html"); 
&checkpass;
	unless (open(DBFILE, "< $emailfile")) {
	    &showmsg("red","$txt{'600'}","$txt{'601'}", "Javascript:history.back()");
	    die;
	    };
	unless(flock(DBFILE, 1)) { &showmsg("red","$txt{'613'}","$txt{'614'}","javascript:history.back()");die;};
	# read in email adresses
	@emails = <DBFILE>;
	close DBFILE;
	print "\n\n";
	print<<EOT;
<title>$txt{'505'}</title></head>
<body bgcolor="#bddeff">
<center>
<table bgcolor="#bddeff" border="1" cellspacing="0" cellpadding="5">
<tr bgcolor="297bce">
    <td align="center"><font face="arial, helvetica" color="#ffffff" size="5">$txt{'505'}</font></td>
</tr>
<tr>
    <td>
    <font size="3" face="arial, helvetica" color="#000000">$txt{'506'}</font>
    </td>
</tr>
<tr>
    <td>
	<table border="0" width="100%" cellspacing="0" cellpadding="5">
	<tr>
	    <td align="right" width="1%"><font size="2" face="arial, helvetica" color="#000000"><b>$txt{'502'}:</b></font></td>
	    <td align="left" width="99%" bgcolor="#eeeeee"><font size="2" face="arial, helvetica" color="#0000ff">$absender</font></td>
	</tr>
	<tr>
	    <td align="right" width="1%"><font size="2" face="arial, helvetica" color="#000000"><b>$txt{'503'}:</b></font></td>
	    <td align="left" width="99%" bgcolor="#eeeeee"><font size="2" face="arial, helvetica" color="#0000ff">$betreff</font></td>
	</tr>
	<tr>
	    <td align="right" valign="top" width="1%"><font size="2" face="arial, helvetica" color="#000000"><b>$txt{'504'}:</b></font></td>
	    <td align="left" valign="top" width="99%" bgcolor="#f9f9f9"><font size="2" face="arial, helvetica" color="#000000">$msgtxt_ntobr</textarea></font></td>
	</tr>
	</table>
	<form name="newsletterwrite" action="$progurl" method="POST" style="margin-bottom:0px;">
	<input type="hidden" name="action" value="ac_writemail2">
	<table border="0" width="100%" cellspacing="0" cellpadding="5">
	<tr>
	    <td align="right"><font size="2" face="arial, helvetica" color="#000000">$txt{'502'}:</font></td>
	    <td align="left"><font size="2" face="arial, helvetica" color="#000000"><input type="text" name="absender" size="18" maxlength="50" value="$absender"></font></td>
	</tr>
	<tr>
	    <td align="right"><font size="2" face="arial, helvetica" color="#000000">$txt{'503'}:</font></td>
	    <td align="left"><font size="2" face="arial, helvetica" color="#000000"><input type="text" name="betreff" size="30" maxlength="120" value="$betreff"></font></td>
	</tr>
	<tr>
	    <td align="right" valign="top"><font size="2" face="arial, helvetica" color="#000000">$txt{'504'}:</font></td>
	    <td align="left" valign="top"><font size="2" face="arial, helvetica" color="#000000"><textarea name="msgtxt" rows="30" cols="73">$msgtxt</textarea></font></td>
	</tr>
	</table>
	<center><br><input type="submit" name="submit" value="$btn{'1'}"></center>
	</form>

	<br><center><a href="$progurl?action=show_admin_center">$txt{'1'}</a></center>
    </td>
</tr>
</table>
$footer
</center>
</body>
</html>
EOT
}; # End of sub

#######################################################################################
sub do_ac_writemail2
{
&printheader ("text/html"); 
&checkpass;
$absender = $simple_form{'absender'};
$betreff = $simple_form{'betreff'};

    if(($absender ne "") && ($betreff ne "") && ($simple_form{'msgtxt'} ne "")) { 
	unless (open(DBFILE, "< $emailfile")) {
	    &showmsg("red","$txt{'600'}","$txt{'601'}", "Javascript:history.back()");
	    die;
	    };
	unless(flock(DBFILE, 1)) { &showmsg("red","$txt{'613'}","$txt{'614'}","javascript:history.back()");die;};
	# read in email adresses
	@emails = <DBFILE>;
	close DBFILE;
	&showmsg("green","$txt{'641'}","$txt{'642'} <br><br>$txt{'643'} <a href=\"$progurl?action=show_mail_status\">$txt{'644'}</a>.","$progurl?action=ac_writemail","$progurl?action=show_admin_center");
	# initialise counter for emails
	my $mailcounter = 0;
	my $nummails = @emails;
	foreach (@emails) {
	$mailcounter++;
	chop($_);
	# open status file and write actual status to it
	unless (open(STATUS, "> status.lck")) {
	    &showmsg("red","$txt{'611'}","$txt{'612'}", "Javascript:history.back()");
	    die;
	    };
	unless(flock(STATUS, 2)) { &showmsg("red","$txt{'623'}","$txt{'624'}","javascript:history.back()");die;};
	print STATUS "$txt{'2'} $mailcounter $txt{'3'} $nummails: $_\n";
	close STATUS;
	&setsecurepath;
	# here the mail is sent, we open a pipe to sendmail and write into the pipe:
	    open(MAIL, "|$mailprog -t -i -f$webmaster");
	    print MAIL "To: $_\n";
	    print MAIL "From: $absender\n";
	    print MAIL "Subject: $betreff\n";
	    print MAIL "Content-Type: text/plain; charset=\"$charset\"\n";
	    print MAIL "Content-Transfer-Encoding: 8-bit\n";
	    print MAIL "X-Mailer: $version http://www.erdfunkstelle.de/newspro\n";
	    print MAIL <<"EOT";

$simple_form{'msgtxt'}

EOT
	    close MAIL;
	};
    } else {
    # an error occured. here we find out which one:
	# the sender email adress was empty
	unless ($absender ne "") {
	    &showmsg("red","$txt{'645'}", "$txt{'646'}","Javascript:history.back()");
	    die;
	    };
	# the subject field was emtpy
	unless ($betreff ne "") {
	    &showmsg("red","$txt{'647'}", "$txt{'648'}","Javascript:history.back()");
	    die;
	    };
	# the body was empty
	unless ($simple_form{'msgtxt'} ne "") {
	    &showmsg("red","$txt{'649'}", "$txt{'650'}","Javascript:history.back()");
	    die;
	    };
	# password was not correct/cookie did not exist
	&showmsg("red","$txt{'651'}", "$txt{'652'}", "$progurl");
	die;
    }; ### End of if-clause ###
}; # end of sub

#######################################################################################
sub do_ac_download_db
{
&checkpass;
# open the email database
unless (open(DBFILE, "< $emailfile")) {
    &printheader ("text/html"); 
    &showmsg("red","$txt{'600'}","$txt{'601'}", "Javascript:history.back()");
    die;
    };
unless(flock(DBFILE, 1)) { &printheader ("text/html"); &showmsg("red","$txt{'613'}","$txt{'614'}","javascript:history.back()");die;};
# send complete email-db stream to browser and emulate a zip file
# print out header first:
print "Content-Type: application/zip","\n";
print "Content-Disposition: attachment; filename=$emailfile","\n";
print "\n\n";
# and now send the stream:
while($line = <DBFILE>) {
    print $line; 
    };
close DBFILE;
}; # end of sub

#######################################################################################
sub parse_form_data
{
    local (*FORM_DATA) = @_;
    local  ( $request_method, $query_string, @key_value_pairs, $key_value, $key, $value);
    $request_method = $ENV{'REQUEST_METHOD'};
    if ($request_method eq "GET") {
	$query_string = $ENV{'QUERY_STRING'};
    } elsif ($request_method eq "POST") {
	read (STDIN, $query_string, $ENV{'CONTENT_LENGTH'});
    };
    @key_value_pairs = split(/&/, $query_string);
    foreach $key_value (@key_value_pairs) {
	($key, $value) = split (/=/, $key_value);
	if (defined($value)) {$value =~ tr/+/ /;
	    $value =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack ("C", hex ($1))/eg;};
	if (defined($FORM_DATA{$key})) {
	    $FORM_DATA{$key} = join ("\0", $FORM_DATA{$key}, $value);
	} else {
	    $FORM_DATA{$key} = $value;
	}
    }
}; # end of sub

#######################################################################################
sub loadcookie
{
    foreach(split(/;/,$ENV{'HTTP_COOKIE'})) {
	$_ =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	(my $cookie_name,my $cookie_value) = split(/=/);	# split cookie-name from cookie-value
	$cookie_name =~ s/^\ *//g;				# remove trailing whitespaces from cookie-names
	$COOKIE{$cookie_name} = $cookie_value;			# fill hash with values
    }
    return $COOKIE{$newslettercookie};	# return correct cookie from hash.
}; # end of sub

#######################################################################################
sub showmsg
{
    # this function shows a formatted message to the user
    # and creates the links for "back" and "forward".
    # the function expects the variables in following order:
    #
    # &showmsg("html-color", "page-title", "message text", "URL for back-link", "URL for forward-link");
    # the URL for "forward" is optional.

# begin
    # get variables
    my $color = $_[0];
    my $title = $_[1];
    my $msgtxt = $_[2];
    my $back = $_[3];
    my $forward = $_[4];

    print <<EOT;
<title>$txt{'53'}: $title</title>
</head>
<body bgcolor="#bddeff">
<center>
<table bgcolor="#bddeff" width=500 border="1" cellspacing="0" cellpadding="5">
<tr bgcolor="#297bce">
    <td align="center"><font face="arial, helvetica" color="#ffffff" size="5">$txt{'53'}: $title</font></td>
</tr>
<tr>
    <td>
    <font size="3" face="arial, helvetica" color="#000000">&nbsp;</font></td>
</tr>
<tr>
    <td>
    <font size="3" face="arial, helvetica" color="$color"><center><b>$title</b></center></font>
<br>
    <font size="2" face="arial, helvetica" color="#000000">
<b>$txt{'54'}:</b><br><br>
$msgtxt
<br><br><center>
EOT
# check if the fourth variable has been filled and if true include
# the forward button
if ($forward) { 
    print "<a href=\"$back\">$txt{'50'}</a> | <a href=\"$progurl?action=show_admin_center\">$txt{'51'}</a> | <a href=\"$forward\"><b>$txt{'52'}</b></a>"; 
    }
else { print "<a href=\"$back\"><b>$txt{'50'}</b></a> | <a href=\"$progurl?action=show_admin_center\">$txt{'51'}</a>";
    };
###
###
    print <<EOT;
</center></font>
<br>
</td>
    </td>
</tr>
</table>
$footer
</center>
</body>
</html>
EOT
}; # End of sub

#######################################################################################
sub checkpass {
$header = $_[0];
$password = &loadcookie;
    unless (open(PWFILE, "< ./passwd.dat")) {
	if ($header) { &printheader("$header"); }; 
	&showmsg("red","$txt{'605'}","$txt{'606'}","$progurl?action=show_admin_center");
	die;
	};
    unless(flock(PWFILE, 1)) { if ($header) { &printheader("$header"); }; &showmsg("red","$txt{'617'}","$txt{'618'}","javascript:history.back()");die;};
    $line = <PWFILE>; #read in password from file.
    close PWFILE;
    unless ($line eq $password) {
	if ($header) { &printheader("$header"); }; 
	&showmsg("red","$txt{'651'}","$txt{'652'}","$progurl");
	die;
	};
};

#######################################################################################
sub do_logout {
&checkpass ("text/html");
&printheader ("text/html","$newslettercookie=invalid");
$ENV{'HTTP_COOKIE'} = qq~$newslettercookie=invalid~;
print "<meta http-equiv=\"refresh\" content=\"0; URL=$progurl\"></head></html>"; # redirect to login page
};

#######################################################################################
sub do_inccounter {
# this function increases the user counter by one
unless(stat("newspro.cnt")) {
    &update_usercounter;
    };
unless(open(COUNTERFILE, "< newspro.cnt")) {
    &printheader ("text/html");
    &showmsg("red","$txt{'653'}","$txt{'654'}","Javascript:history.back()"); die;
    };
my $counter;
$counter = <COUNTERFILE>;
close COUNTERFILE;
unless(open(COUNTERFILE, "> newspro.cnt")) {
    &printheader ("text/html");
    &showmsg("red","$txt{'655'}","$txt{'656'}","Javascript:history.back()");
    die;
    };
$counter++;
print COUNTERFILE $counter;
close COUNTERFILE;
};

#######################################################################################
sub do_deccounter {
# this function decreases the usercounter by one
unless(stat("newspro.cnt")) {
    &update_usercounter;
    };
unless(open(COUNTERFILE, "< newspro.cnt")) {
    &printheader ("text/html");
    &showmsg("red","$txt{'653'}","$txt{'654'}","Javascript:history.back()");
    die;
    };
my $counter;
$counter = <COUNTERFILE>;
close COUNTERFILE;
unless(open(COUNTERFILE, "> newspro.cnt")) {
    &printheader ("text/html");
    &showmsg("red","$txt{'655'}","$txt{'656'}","Javascript:history.back()");
    die;
    };
$counter--;
print COUNTERFILE $counter;
close COUNTERFILE;
};

#######################################################################################
sub do_getcounter {
# reads the user counter file and returns a number representing the subscribed people
unless(stat("newspro.cnt")) {
    &update_usercounter;
    };
&update_usercounter;
unless(open(COUNTERFILE, "< newspro.cnt")) { &printheader ("text/html"); &showmsg("red","$txt{'653'}","$txt{'654'}","Javascript:history.back()"); die; };
my $counter;
$counter = <COUNTERFILE>;
close COUNTERFILE;
return $counter;
};

#######################################################################################
sub update_usercounter {
# creates the user counter
unless(stat("newspro.cnt")) {
    unless(open(COUNTERFILE, "> newspro.cnt")) { &printheader ("text/html"); &showmsg("red","$txt{'655'}","$txt{'656'}","Javascript:history.back()"); die; };
    close COUNTERFILE;
    };
unless(stat($emailfile)) {
    unless(open(MAILFILE, "> $emailfile")) { &printheader ("text/html"); &showmsg("red","$txt{'602'}","$txt{'603'}","javascript:history.back()");die; };
    };
    close MAILFILE;
unless(open(MAILFILE, "< $emailfile")) { &printheader ("text/html"); &showmsg("red","$txt{'600'}","$txt{'601'}","javascript:history.back()"); die; };
my @countarray = <MAILFILE>;
close MAILFILE;
my $counter = @countarray;
unless(open(COUNTERFILE, "> newspro.cnt")) { &printheader ("text/html"); &showmsg("red","$txt{'655'}","$txt{'656'}","Javascript:history.back()"); die; };
print COUNTERFILE $counter;
close COUNTERFILE;
};

#######################################################################################
sub do_ac_bugreport
{
&printheader ("text/html"); 
&checkpass;
# fill variables with informatinal things
my $http_server = $ENV{'SERVER_SOFTWARE'};
my $document_root = $ENV{'DOCUMENT_ROOT'};
my $script_name = $ENV{'SCRIPT_NAME'};
my $server_name = $ENV{'SERVER_NAME'};

print<<EOT;
<title>$txt{'507'}</title>
</head>
<body bgcolor="#bddeff">
<center>
<table bgcolor="#bddeff" border="1" cellspacing="0" cellpadding="5">
<tr bgcolor="297bce">
    <td align="center"><font face="arial, helvetica" color="#ffffff" size="5">$txt{'507'}</font></td>
</tr>
<tr>
    <td>
    <font size="3" face="arial, helvetica" color="#000000">$txt{'508'}</font>
    </td>
</tr>
<tr>
    <td>
	<form name="bugreport" action="$progurl" method="POST" style="margin-bottom:0px;">
	<input type="hidden" name="action" value="ac_bugreport2">
	<table border="0" width="100%" cellspacing="0" cellpadding="5">
	<tr>
	    <td align="right"><font size="2" face="arial, helvetica" color="#000000">$txt{'514'}:</font></td>
	    <td align="left"><font size="2" face="arial, helvetica" color="#000000"><input type="text" name="newspro_version" size="18" maxlength="50" value="$version"></font></td>
	</tr>
	<tr>
	    <td align="right"><font size="2" face="arial, helvetica" color="#000000">$txt{'510'}:</font></td>
	    <td align="left"><font size="2" face="arial, helvetica" color="#000000"><input type="text" name="absender" size="18" maxlength="50" value="$webmaster"><font color="#999999">&nbsp;&nbsp;$txt{'512'}</font></font></td>
	</tr>
	<tr>
	    <td align="right"><font size="2" face="arial, helvetica" color="#000000">$txt{'523'}:</font></td>
	    <td align="left"><font size="2" face="arial, helvetica" color="#000000"><select name="dringlichkeit">
		<option value="please choose">$txt{'531'}</option>
		<option value="browser crash">$txt{'524'}</option>
		<option value="specification violation">$txt{'525'}</option>
		<option value="trivial bug">$txt{'526'}</option>
		<option value="significant bug">$txt{'527'}</option>
		<option value="security bug">$txt{'528'}</option>
		<option value="wishlist/enhancement">$txt{'529'}</option>
		<option value="other">$txt{'530'}</option>
		</select>
		</font></td>
	</tr>
	<tr>
	    <td align="right"><font size="2" face="arial, helvetica" color="#000000">$txt{'509'}:</font></td>
	    <td align="left"><font size="2" face="arial, helvetica" color="#000000"><input type="text" name="betreff" size="30" maxlength="120"><font color="#999999">&nbsp;&nbsp;$txt{'513'}</font></font></td>
	</tr>
	<tr>
	    <td align="right" valign="top"><font size="2" face="arial, helvetica" color="#000000">$txt{'511'}:</font></td>
	    <td align="left" valign="top"><font size="2" face="arial, helvetica" color="#000000"><textarea name="msgtxt" rows="15" cols="40" wrap="off"></textarea></font></td>
	</tr>
	<tr>
	    <td align="right" valign="top"><font size="2" face="arial, helvetica" color="#000000">$txt{'515'}:</font></td>
	    <td align="left" valign="top"><font size="2" face="arial, helvetica" color="#000000">
		$txt{'516'}: $http_server<br>
		$txt{'517'}: $document_root<br>
		$txt{'518'}: $mailprog<br>
		$txt{'519'}: $progurl<br>
		$txt{'520'}: $script_name<br>
		$txt{'521'}: $language<br>
		$txt{'522'}: $server_name<br>
		</font>
		<input type="hidden" name="http_server" value="$http_server">
		<input type="hidden" name="document_root" value="$document_root">
		<input type="hidden" name="sendmail_path" value="$mailprog">
		<input type="hidden" name="progurl_from_file" value="$progurl">
		<input type="hidden" name="scripturl" value="$script_name">
		<input type="hidden" name="language_from_file" value="$language">
		<input type="hidden" name="dns_name" value="$server_name">
		</td>
	</tr>
	</table>
	<center><br><input type="submit" name="submit" value="$btn{'1'}"></center>
	</form>
	<br><center><a href="$progurl?action=show_admin_center">$txt{'1'}</a></center>
    </td>
</tr>
</table>
$footer
</center>
</body>
</html>
EOT
}; # End of sub

#######################################################################################
sub do_ac_bugreport2
{
&checkpass;
# fill local variables with thing from the web bug report form
my $newspro_version = $simple_form{'newspro_version'};
my $absender = $simple_form{'absender'};
my $severity = $simple_form{'dringlichkeit'};
my $betreff = $simple_form{'betreff'};
my $msgtxt = $simple_form{'msgtxt'};
my $http_server = $simple_form{'http_server'};
my $document_root = $simple_form{'document_root'};
my $sendmail_path = $simple_form{'sendmail_path'};
my $progurl_from_file = $simple_form{'progurl_from_file'};
my $scripturl = $simple_form{'scripturl'};
my $language_from_file = $simple_form{'language_from_file'};
my $dns_name = $simple_form{'dns_name'};

### Vor dem Senden auf Fehler prfen ###
    if(($betreff ne "") && ($simple_form{'msgtxt'} ne "")) {
	    &setsecurepath;
	### Verschicken der Mail ###
	    open(MAIL, "|$mailprog -t -i");
	    print MAIL "To: tr\@erdfunkstelle.de\n";
	    print MAIL "From: $absender\n";
	    print MAIL "Subject: $betreff\n";
	    print MAIL <<EOT;
Fehlerbericht zu NewsPro:
NewsPro Version:            $newspro_version
Dringlichkeit:              $severity
HTTP Server:                $http_server
Dokument Root:              $document_root
Sendmail Pfad:              $sendmail_path
Programmpfad (aus progurl): $progurl_from_file
Programmpfad (aus ENV):     $scripturl
Sprachdatei:                $language_from_file
DNS-Name:                   $dns_name

---------------------------

Mitteilung:

$msgtxt
EOT
    close MAIL;
    &printheader ("text/html"); 
    &showmsg("green","$txt{'657'}","$txt{'658'}","javascript:history.back()");    
    } else {
    &printheader ("text/html"); 
    # an error occured. we will try to find out what happened:
	# sender field was empty:
	unless ($betreff ne "") {
	    &showmsg("red","$txt{'647'}", "$txt{'648'}","Javascript:history.back()");
	    die;
	    };
	# body of bug report form was empty:
	unless ($simple_form{'msgtxt'} ne "") {
	    &showmsg("red","$txt{'649'}", "$txt{'650'}","Javascript:history.back()");
	    die;
	    };
	# if the password did not match:
	&showmsg("red","$txt{'651'}", "$txt{'652'}", "$progurl");
	die "AC_WRITEMAIL_2";
    }; ### End of if-clause ###
    
}; # end of sub

#######################################################################################
sub setsecurepath {
    $ENV{'PATH'} = "/usr/local/bin:/usr/bin:/usr/X11R6/bin:/bin:";	# for security reasons set $ENV to a trustworthy value!
};

#######################################################################################
sub showfooter {
# set footer
return "<font size=\"1\" color=\"#999999\" face=\"arial\">$version &copy; 2002 Thomas Reitelbach<br><a href=\"http://www.erdfunkstelle.de/newspro/index.shtml\"><font size=\"1\" color=\"#999999\" face=\"arial\">www.erdfunkstelle.de/newspro</font></a></font>"
};

#######################################################################################
sub printheader {
my $content_type = $_[0];
my $set_cookie = $_[1];
if (defined($content_type)) 	{ if ($content_type) 	{ print STDOUT "Content-type: $content_type\n"; };};
if (defined($set_cookie)) 	{ if ($set_cookie ne "")	{ print "P3P: CP=\"NOI DSP COR DEVa TAIa OUR BUS UNI\"\n"; print STDOUT "Set-cookie: $set_cookie\n"; };};
print STDOUT "\n";

# if content_type is text/html also print some html text for charset and so on...
if ($content_type eq "text/html") {
    print STDOUT "<html>\n";
    print STDOUT "<meta http-equiv=\"content-type\" content=\"text/html; charset=$charset\">\n";
    };
};

#######################################################################################
sub do_helpimage {
# this routine shows the help image (a question mark)
# it's 12x12 pixel
&printheader ("image/gif");
print <<EOT;
GIF89a){Ψ){){!
,	wRQU9!dKJ);
EOT
};

#######################################################################################
sub do_help {
&printheader ("text/html");
#&checkpass;	#may be i include a password checking routine here, too...
my $topic = $simple_form{'topic'};		# read in help topic number
if ($topic !~ m/^(\d\d\d\d\d)/g ) {die;};	# topic number must be exactly 5 digits! this is for security reasons.

print <<EOT;
<title>Hilfe</title>
</head>
<body bgcolor="#bddeff">
<center>
<table bgcolor="#bddeff" border="1" cellspacing="0" cellpadding="5">
<tr bgcolor="#297bce">
    <td align="center"><font face="arial, helvetica" color="#ffffff" size="5">Hilfe</font></td>
</tr>
<tr>
    <td>
    <font size="3" face="arial, helvetica" color="#000000">$txt{'101'}:</font></td>
</tr>
<tr>
    <td>
	<table border="0" cellspacing="0" cellpadding="5">
	<tr>
	    <td align="left" valign="middle"><font size="2" face="arial, helvetica" color="#000000">$txt{'102'}:</font></td>
	    <td align="left" valign="middle"><font size="2" face="arial, helvetica" color="#000000">
		<form name="adminlogon" action="$progurl" method="POST" style="margin-bottom:0px;">
		<input type="hidden" name="action" value="show_admin_center">
		<font size="2" face="arial, helvetica"><input type="password" name="passwort" value="" size="18" maxlength"50">
		<input type="submit" name="submit" value="$btn{'1'}"></font>
		</form>
		</td>
	</tr>
	</table>
    </td>
</tr>
</table>
$footer
</center>
</body>
</html>
EOT
};